#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_with	tests	# py.test calls

# FIXME - somehow make build process to leave source C files, so debuginfo will pick these up. For now just disable debuginfo packages
%define		_enable_debug_packages 0

%define		pytools_ver	2025.1.2
%define		pypi_name	pyopencl
Summary:	Python 2 wrapper for OpenCL
Summary(pl.UTF-8):	Interfejs Pythona 2 do OpenCL
Name:		python3-pyopencl
Version:	2025.1
Release:	1
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.python.org/simple/pyopencl/
Source0:	https://files.pythonhosted.org/packages/source/p/%{pypi_name}/%{pypi_name}-%{version}.tar.gz
# Source0-md5:	405536951035e143f97a415edb64900d
URL:		http://mathema.tician.de/software/pyopencl
BuildRequires:	OpenCL-devel >= 1.2
BuildRequires:	libstdc++-devel >= 6:4.3
BuildRequires:	rpmbuild(macros) >= 1.710
BuildRequires:	python3-build
BuildRequires:	python3-cffi >= 1.1.0
BuildRequires:	python3-installer
BuildRequires:	python3-devel >= 1:3.2
BuildRequires:	python3-numpy-devel
%if %{with tests}
BuildRequires:	python3-Mako >= 0.3.6
BuildRequires:	python3-appdirs >= 1.4.0
BuildRequires:	python3-decorator >= 3.2.0
BuildRequires:	python3-pytest >= 2
BuildRequires:	python3-pytools >= %{pytools_ver}
BuildRequires:	python3-six >= 1.9.0
%endif
%if %{with doc}
BuildRequires:	python3-numpy
BuildRequires:	python3-pytools >= %{pytools_ver}
BuildRequires:	python3-six >= 1.9.0
BuildRequires:	python3-sphinx_bootstrap_theme
BuildRequires:	sphinx-pdg-3
%endif
Requires:	OpenCL >= 1.1
Requires:	python3-appdirs >= 1.4.0
Requires:	python3-decorator >= 3.2.0
Requires:	python3-numpy
Requires:	python3-pytools >= %{pytools_ver}
Suggests:	python3-Mako >= 0.3.6
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PyOpenCL lets you access GPUs and other massively parallel compute
devices from Python. It tries to offer computing goodness in the
spirit of its sister project PyCUDA.

%description -l pl.UTF-8
PyOpenCL pozwala na dostęp z poziomu Pythona do GPU i innych znacznie
zrównoleglonych jednostek obliczeniowych. Próbuje zaoferować
możliwości obliczeniowe w tym samym stylu, co siostrzany projekt
PyCUDA.

%package apidocs
Summary:	Documentation for PyOpenCL module
Summary(pl.UTF-8):	Dokumentacja modułu PyOpenCL
Group:		Documentation
BuildArch:	noarch

%description apidocs
Documentation for PyOpenCL module.

%description apidocs -l pl.UTF-8
Dokumentacja modułu PyOpenCL.

%package examples
Summary:	Examples for PyOpenCL module
Summary(pl.UTF-8):	Przykłady do modułu PyOpenCL
Group:		Documentation

%description examples
Examples for PyOpenCL module.

%description examples -l pl.UTF-8
Przykłady do modułu PyOpenCL.

%prep
%setup -q -n pyopencl-%{version}

%{__sed} -i -e '1s,/usr/bin/env python,%{__python},' examples/*.py

%build
%py3_build_pyproject

%if %{with tests}
%{__python3} -m zipfile -e build-3/*.whl build-3-test
# use explicit plugins list for reliable builds (delete PYTEST_PLUGINS if empty)
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS= \
%{__python3} -m pytest -o pythonpath="$PWD/build-3-test" tests
%endif

%if %{with doc}
%{__python3} -m zipfile -e build-3/*.whl build-3-doc
%{__make} -C doc html \
	PYTHONPATH="$(pwd)/build-3-doc" \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -a examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.rst
%dir %{py3_sitedir}/pyopencl
%attr(755,root,root) %{py3_sitedir}/pyopencl/_cl.*.so
%{py3_sitedir}/pyopencl/*.py
%{py3_sitedir}/pyopencl/__pycache__
%{py3_sitedir}/pyopencl/characterize
%{py3_sitedir}/pyopencl/cl
%{py3_sitedir}/pyopencl/compyte
%{py3_sitedir}/pyopencl-%{version}.dist-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc doc/_build/html/*
%endif

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}
%changelog
* Sun May 04 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-pyopencl.git;a=log;h=auto/th/python3-pyopencl-2025.1-1

* Sun May 04 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 6085809
- Up to 2025.1 (but one FIXME needed)

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> aa729c7
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 106c023
- python 3.13 rebuild

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 8db8914
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> c5012b4
- rebuild with python 3.10

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 26b671a
- rebuild with separate debuginfo build-ids

* Sat Mar 06 2021 Jan Palus <atler@pld-linux.org> 8124d50
- fix shebangs in examples; rel 4

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 7999fdf
- unconditional noarch subpackages

* Tue Nov 05 2019 Jan Rękorajski <baggins@pld-linux.org> a1554f5
- docs need python3 to build
- rel 3

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> a054282
- rebuild with python 3.8
- release 2 (by relup.sh)

* Fri Sep 14 2018 Elan Ruusamäe <glen@pld-linux.org> 617f475
- use reusable source url

* Tue Jul 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8b7bb91
- up to 2018.1.1

* Tue Jul 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 81f192f
- release 4 (by relup.sh)

* Sat Mar 18 2017 Jakub Bogusz <qboosh@pld-linux.org> 604671b
- adjusted py.test invocation to work with py.test 2.x/3.0.x

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> b0e728e
- python 3.6
- release 3 (by relup.sh)

* Sun May 22 2016 Jakub Bogusz <qboosh@pld-linux.org> a8c1d76
- stick to OpenCL 1.1 Requires; 1.2 symbols are required from icd library, not the backing one
- release 2

* Sun May 22 2016 Jakub Bogusz <qboosh@pld-linux.org> 8d6d4e8
- more doc BRs, force sphinx-build for python 2

* Sat May 21 2016 Jakub Bogusz <qboosh@pld-linux.org> dc8f5b2
- updated to 2016.1
- removed obsolete doc patch

* Fri Apr 29 2016 Elan Ruusamäe <glen@delfi.ee> c01f136
- noarch apidocs

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 5b44965
- BR: rpmbuild(macros) >= 1.710

